
/* enforce periodic boundary conditions */

#include "decs.h"

/* enforce boundary conditions for variable var at time tcurr */
void bound_var(REAL(*var)[NY + 4], double tcurr)
{
	int i, j;
	void remap(REAL * vp, double del);

	/* x-boundary */
	for (j = 0; j < NY; j++) {
		var[NX][j] = var[0][j];
		var[NX + 1][j] = var[1][j];
		var[-1][j] = var[NX - 1][j];
		var[-2][j] = var[NX - 2][j];
	}
	remap(var[NX], q * W * Lx * tcurr / dy);
	remap(var[NX + 1], q * W * Lx * tcurr / dy);
	remap(var[-1], -q * W * Lx * tcurr / dy);
	remap(var[-2], -q * W * Lx * tcurr / dy);

	/* y- boundary */
	for (i = -2; i < NX + 2; i++) {
		var[i][-1] = var[i][NY - 1];
		var[i][-2] = var[i][NY - 2];
		var[i][NY] = var[i][0];
		var[i][NY + 1] = var[i][1];
	}
}
