
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#define REAL double
#define NX 512
#define NY 512

extern REAL S_matrix[NX + 4][NY + 4];
extern REAL e_matrix[NX + 4][NY + 4];
extern REAL vx_matrix[NX + 4][NY + 4];
extern REAL vy_matrix[NX + 4][NY + 4];
extern REAL pot_matrix[NX + 4][NY + 4];
extern REAL fl_matrix[NX + 4][NY + 4];
extern REAL tau_matrix[NX + 4][NY + 4];
extern REAL tcnew_matrix[NX + 4][NY + 4];
extern REAL Tm_matrix[NX + 4][NY + 4];
extern char rgm_matrix[NX + 4][NY + 4];
extern REAL ProPg_matrix[NX + 4][NY + 4];
extern REAL mintc_matrix[NX + 4][NY + 4];
extern REAL flr_matrix[NX + 4][NY + 4];
extern REAL work1_matrix[NX + 4][NY + 4];
extern REAL work2_matrix[NX + 4][NY + 4];
extern REAL work3_matrix[NX + 4][NY + 4];
extern REAL work4_matrix[NX + 4][NY + 4];
extern REAL work5_matrix[NX + 4][NY + 4];
extern REAL work6_matrix[NX + 4][NY + 4];

extern REAL(*S)[NY + 4];
extern REAL(*e)[NY + 4];
extern REAL(*vx)[NY + 4];
extern REAL(*vy)[NY + 4];
extern REAL(*pot)[NY + 4];
extern REAL(*fl)[NY + 4];
extern REAL(*tau)[NY + 4];
extern REAL(*tcnew)[NY + 4];
extern REAL(*Tm)[NY + 4];
extern char (*rgm)[NY + 4];
extern REAL(*ProPg)[NY + 4];
extern REAL(*mintc)[NY + 4];
extern REAL(*flr)[NY + 4];
extern REAL(*work1)[NY + 4];
extern REAL(*work2)[NY + 4];
extern REAL(*work3)[NY + 4];
extern REAL(*work4)[NY + 4];
extern REAL(*work5)[NY + 4];
extern REAL(*work6)[NY + 4];

extern double cour;
extern double cs;
extern double gam, g2;
extern double dx, dy;
extern double dt;
extern double t, tf;
extern double nu_vnr;
extern double nu_l;
extern double G;
extern double cool_fac;
extern double mu;

extern int i_crit_dt;
extern int j_crit_dt;
extern int i_crit_tc;
extern int j_crit_tc;
extern int dt_crit;

extern double DTd;
extern double DTi;
extern double DTl;
extern double res;
extern double nu_sh;

extern double W;
extern double omega;
extern double q;
extern double Lx;
extern double Ly;
extern double K0;
extern double alphah, alphag, cs0, u0, S0;
extern double tau0, tc0, T0, tcmin, tcnew_min;
extern double S0cgs, Wcgs, rho0cgs;
extern REAL T, rhocgs, Scgs;
extern double kx0, ky0;
extern double kmax, ksqmax;
extern double fx, fy;
extern double Qeq;
extern double pamp;
extern char regime;
extern double ProPg0;
extern int is_restart;

extern int dump_cnt;
extern int im_cnt;

#define SMALL	1.e-20
#define SMIN	1.e-6		/* minimum density */
#define EMIN	1.e-6		/* minimum internal energy */

#define SIMPLECOOL	1
#define FULLCOOOL	0

/* subroutines */

int my_nint(double dum);
void bound_var(REAL(*var)[NY + 4], double tcurr);
void diag(int call_code);
void dump(FILE * fp);
void image_ppm(FILE * fp, REAL(*imvar)[NY + 4]);
void perturb(double amp);
void potsolv(REAL(*dens)[NY + 4], REAL(*psi)[NY + 4]);
void remap(REAL * var, double del);
void row_unroll(REAL * var, REAL del);
void unroll(REAL(*var)[NY + 4], REAL delt);
