#include "decs.h"

void dump(FILE * fp)
{
	int i, j;
	double p, Save;

	fprintf(fp, "%d %d %lf %lf %lf %lf %lf\n", NX, NY, Lx, Ly, W, q,
		t);

#if FULLCOOL
	fprintf(fp,
		"#%8s %8s %10s %8s %8s %8s %8s %8s %8s %8s %8s %8s %8s %8s %8s\n",
		"x", "y", "s", "p", "vx", "vy", "pot", "vort", "divv",
		"tau", "tcnew", "T", "rgm", "ProPg", "mintc");
#endif
#if SIMPLECOOL
	fprintf(fp, "#%8s %8s %10s %8s %8s %8s %8s %8s %8s \n",
		"x", "y", "s", "p", "vx", "vy", "pot", "vort", "divv");
#endif

	for (i = 0; i < NX; i++)
		for (j = 0; j < NY; j++) {
			if (fabs(g2 - 1.) > 1.e-6)
				p = (g2 - 1.) * e[i][j];
			else
				p = cs * cs * S[i][j];

			fprintf(fp, "%8.4g %8.4g ",
				(i - NX / 2 + 0.5) * dx,
				(j - NY / 2 + 0.5) * dy);
			fprintf(fp, "%10.6g %8.4g ", S[i][j], p);
			fprintf(fp, "%8.4g %8.4g ", vx[i][j], vy[i][j]);
			fprintf(fp, "%8.4g ", pot[i][j]);

			/* potential vorticity */
			Save =
			    0.25 * (S[i][j] + S[i - 1][j] + S[i][j - 1] +
				    S[i - 1][j - 1]);
			fprintf(fp, "%8.4g ",
				((vy[i][j] - vy[i - 1][j]) / dx -
				 (vx[i][j] - vx[i][j - 1]) / dy) / Save);

			/* divv */
			fprintf(fp, "%8.4g ",
				(vx[i + 1][j] - vx[i][j]) / dx -
				(vy[i][j + 1] - vy[i][j]) / dy);

#if FULLCOOL
			/* tau,tc */
			fprintf(fp, "%8.4g %8.4g ", tau[i][j],
				tcnew[i][j]);

			/* T, opacity regime */
			fprintf(fp, "%8.4g %8c ", Tm[i][j], rgm[i][j]);

			/* Pr/Pg */
			fprintf(fp, "%8.4g ", ProPg[i][j]);

			/* tcmin/tc */
			fprintf(fp, "%8.4g ", mintc[i][j]);
#endif
			fprintf(fp, "\n");
		}
}
