
/* function for shifting a column of data forward by some amount */

#include "decs.h"

void remap(REAL * var, double del)
{
	static int firstc = 1;
	static REAL *tmp ;
	int j, jshift, jp;
	double fshift;

	if (firstc) {
		firstc = 0;
		tmp = malloc((NY+2)*sizeof(double)) ;
		tmp = &(tmp[1]) ;
	}
	/* separate into integral & fraction part of shift */
	while (del < 0.)
		del += NY;
	jshift = (int) floor(del);
	fshift = del - jshift;

	/* simplified version */
	/* do integral part of shift */
	for (j = 0; j < NY; j++) {
		jp = (j + jshift) % NY;
		tmp[j] = var[jp];
	}

	/* do fractional part of shift */
	for (j = 0; j < NY; j++) {
		jp = (j + 1) % NY;
		var[j] = (1. - fshift) * tmp[j] + fshift * tmp[jp];
	}

	/* done! */
}
