#include "decs.h"

void scaling()
{
	double kappa0, kB, Gcgs, mp, sB, c, A, B, tc0cgs;

	REAL opac(REAL rho, REAL T);

	kappa0 = opac(rho0cgs, T0);

	kB = 1.380658e-16;
	Gcgs = 6.67259e-8;
	mp = 1.6726231e-24;
	sB = 5.67051e-5;
	c = 2.99792458e10;
	A = g2 * kB / (mu * mp);
	B = 2. * A / (M_PI * Gcgs * Qeq);

	S0cgs = sqrt(B * rho0cgs * T0);
	tau0 = 0.5 * S0cgs * kappa0;
	tc0cgs =
	    3. * A * S0cgs * (tau0 +
			      1. / tau0) / (16. * sB * g2 * (g2 -
							     1.) * T0 *
					    T0 * T0);
	Wcgs = M_PI * Gcgs * Qeq * S0cgs / sqrt(A * T0);
	tc0 = tc0cgs * Wcgs;

	ProPg0 = 4. * sB * g2 * T0 * T0 * T0 / (3. * c * A * rho0cgs);
}
