
#include "decs.h"

void step_cool()
{
	int i, j;
	REAL opac(REAL rho, REAL T);
	void bound_var(REAL(*var)[NY + 4], double t);
	double u, s, dudt, dsodu;
	double du, ds, dT, drho, tc;

#if FULLCOOL
	tcnew_min = 1. / SMALL;
#endif
#if SIMPLECOOL
	tcnew_min = tc0;
#endif

	for (i = 0; i < NX; i++)
		for (j = 0; j < NY; j++) {
			u = e[i][j];
			s = S[i][j];

#if FULLCOOL
			/* alternative cooling function */
			du = u / u0;
			ds = s / S0;
			dsodu = ds / du;
			rhocgs = rho0cgs * ds * sqrt(dsodu);
			Scgs = S0cgs * ds;
			T = Tm[i][j] = T0 * du / ds;
			dT = T / T0;
			drho = rhocgs / rho0cgs;
			ProPg[i][j] = ProPg0 * dT * dT * dT / drho;
			tau[i][j] = 0.5 * Scgs * opac(rhocgs, T);
			rgm[i][j] = regime;
			tc = tc0 * (ds * dsodu * dsodu * dsodu) *
			    (tau[i][j] + 1. / tau[i][j]) / (tau0 +
							    1. / tau0);
			tcnew[i][j] = tc + tcmin;
			mintc[i][j] = tcmin / tc;
			if (tcnew[i][j] < tcnew_min) {
				tcnew_min = tcnew[i][j];
				i_crit_tc = i;
				j_crit_tc = j;
			}
			dudt = -u / tcnew[i][j];
#endif

			/* cooling function */
#if SIMPLECOOL
			dudt = -u / tc0;
#endif

			e[i][j] += dt * dudt;
			if (e[i][j] < 0.) {
				fprintf(stdout,
					"step_cool e < 0: %g %d %d %lf %1f\n",
					t, i, j, S[i][j], e[i][j]);
				//exit(0) ;
			}

		}
	bound_var(e, t);

}
