
/* do transport for mean velocity part of vy */
/* most boundary conditions are handled internally */

#include "decs.h"

void sweepym()
{
	void bound_var(REAL(*var)[NY + 4], double t);
	double X, XP, del;
	int i;

	/* mean velocity moves variables by an integral number of
	   zones plus a nonintegral number.  Do integral part here. */
	for (i = 0; i < NX; i++) {
		X = (i + .5) * dx - 0.5 * Lx;
		del = -q * W * X * dt / dy;

		remap(S[i], -del);
		remap(e[i], -del);
		remap(vy[i], -del);
	}
	bound_var(S, t + dt);
	bound_var(e, t + dt);
	bound_var(vy, t + dt);

	for (i = 0; i < NX; i++) {
		XP = i * dx - 0.5 * Lx;
		del = -q * W * XP * dt / dy;
		remap(vx[i], -del);
	}
	bound_var(vx, t + dt);

}
