
/* unroll or roll density grid */

#include "decs.h"

void unroll(REAL(*var)[NY + 4], REAL delt)
{
	REAL X, del;
	int i;
	void row_unroll(REAL * v, REAL del);

	for (i = 0; i < NX; i++) {
		X = (i + 0.5) * dx - 0.5 * Lx;
		del = -q * W * X * delt / dy;
		row_unroll(var[i], del);
	}
}

void acf_unroll(REAL(*var)[NY + 4], REAL delt)
{
	REAL X, del;
	int i;
	void row_unroll(REAL * v, REAL del);

	for (i = 0; i < NX; i++) {
		X = i * dx - 0.5 * Lx;
		del = -q * W * X * delt / dy;
		row_unroll(var[i], del);
	}
}

/* boilerplate of remap, with argument of type REAL */

void row_unroll(REAL * var, REAL del)
{
	static int firstc = 1;
	static double *tmp;
	int i, ishift, ip;
	double fshift;

	if (firstc) {
		firstc = 0;
		tmp = malloc((NY+2)*sizeof(double)) ;
		tmp = &(tmp[1]) ;
	}

	for (i = 0; i < NY; i++)
		tmp[i] = var[i];

	/* separate into integral & fraction part of shift */
	ishift = floor(del);
	fshift = del - ishift;

	/* do integral part of shift */
	for (i = 0; i < NY; i++) {
		ip = i + ishift;
		while (ip > NY - 1)
			ip -= NY;
		while (ip < 0)
			ip += NY;
		var[i] = tmp[ip];
	}

	for (i = 0; i < NY; i++)
		tmp[i] = var[i];

	for (i = 0; i < NY; i++) {
		ip = i + 1;
		if (ip >= NY)
			ip -= NY;
		var[i] = (1. - fshift) * tmp[i] + fshift * tmp[ip];
	}
}
